#include "stdio.h"
#include "math.h"

#define  OS  Mac  /**/ /* Unix */
#if OS==Mac
#include "stdlib.h"
#elif OS==Unix

    typedef unsigned size_t;
    char    *malloc();
 
#endif
 

#define VER       "1.1  "           /* version number */
#define DATE      "July 92"
#define AUTHOR1   "J. Jaime Gomez-Hernandez"
#define ADDRESS1  "Escuela de Ing. de Caminos, Univ. Politecnica, 46071 Valencia, SPAIN"
#define COPYRIGHT "Stanford Center for Reservoir Forecasting (SCRF)\n      and Empresa Nacional de Residuos (ENRESA)"

/* the following definitions correspond to the FILE NAMES */
						
#define GEOMETRY "gcosim3d.geo"  /* this file describes the geometry */
#define VARIOGRAM "gcosim3d.var" /* this file contains the variograms */
#define DATA "gcosim3d.dat"       /* this file contains the intial data */
#define OUTPUT "gcosim3d.out"     /* this file contains the output */
#define DBG  "gcosim3d.dbg"     /* this file contains the error messages 
					   and debugging information */
#define	E  (2.71828182845904523536)
#define UNKNOWN  (-999999.0)
#define TINY (1e-20)

#define MAX(a,b) ((a>b) ? a : b)
#define MIN(a,b) ((a<b) ? a : b)
#define NINT(a)  ((a>0) ? (int)(a+0.5) : (int)(a-0.5))

typedef struct {
	float x,y,z; 
} pt;

typedef struct {
	int x,y,z; 
} ipt;
								   

typedef struct {
	int 	num_struct,*type;
	float	nugget, *sill, *a, cmax,
			dir_cosines[3][3];
	pt		*anis;
} variogram_model;

typedef struct {
	float cosines[3][3];
	pt radius;
	int	rotation;
} search;

typedef struct {
	int		*irx,*iry,*irz,*octant,*index;
	float	*distance;
} template; 

typedef struct {
	int			*ix,*iy,*iz;
	float      	*value;
	int         *index;
} cond_point;
	
/* char            *malloc();
void 		error();       
float 		*vector();
int 		*ivector();
float       **matrix();
float 		***tensor();
void 		input_structure();
void 		print_structure();
float 		gamma0();
float 		cova();
pt 		    rotate();
float 		exponential();
float 		spherical();
float 		gaussian();
float 		linear();
float 		modulus();
void		read_in_geometry();
int 		read_in_variograms();
int 		read_in_conditioning_data();
float    	****allocate_nodes();
float 		****allocate_covariance_tables();
float 		rand0();
int			allocate_template();
void 		initialize_nodes();
void 		initialize_covariance_tables();
void 		initialize_template();
void 		qcksrt();
float 		lookup_cova();
void 		fprint_indicator();
void		a_few_checks();
ipt			get_next_point();
void		allocate_conditioning_data_matrices();
void		initialize_random_path();
int			find_conditioning_points();
int			move_indicator_to_buffer();
void 		build_kriging_system();
void 		solve_kriging_system();
float       obtain_SK_kriging_variance();
void 		do_simulation();
void 		write_out_kriging_weights();
void 		write_out_cpdf();
void 		ludcmp();
void        lubksb();
float       gasdev();
float       obtain_SK_estimate();
*/

#include "gproto12Periodic.h"
