/* Protoypes grabbed from file
** "gmain11.c"
** 1992 Sep 1 (Tue) 10:53:56
*/

int
main(void);

void
write_out_results(FILE *fout,
	ipt from,
	ipt to,
	float ****node,
	int nvar_sim,
	int *simulation_var,
	int isim,
	int nsim);

float
cova(pt point1,
	pt point2,
	variogram_model *var_model);

float
gamma0(pt point1,
	pt point2,
	variogram_model *var_model);

pt
rotate(pt vect,
	float dir_cos[3][3]);

float
exponential(float h,
	float sill,
	float a);

float
hole_effect(float h,
	float sill,
	float a);

float
spherical(float h,
	float sill,
	float a);

float
gaussian(float h,
	float sill,
	float a);

float
linear(float h,
	float slope,
	float power);

float
modulus(pt vect,
	pt anis);

float ****
allocate_nodes(int nvar,
	ipt n,
	short ****node_flag_pointer);

float ****
allocate_covariance_tables(int ncov,
	search srch,
	ipt *dim,
	pt delta,
	int ***lookup_table_pointer);

int
allocate_template(FILE *fperr,
	template *tmp,
	ipt dim,
	search srch,
	pt delta);

void
initialize_nodes(FILE *fperr,
	ipt n_nodes,
	float ****node,
	short ***node_flag,
	int ndata,
	pt coord[],
	int *index,
	float value[],
	pt origin,
	pt delta,
	int nvar,int isim);

void
initialize_covariance_tables(FILE *fperr,
	int dbg,
	int ncov,
	ipt srch_dim,
	pt delta,
	float ***cova_table[],
	variogram_model variogram[],
	int **lookup_table);

void
initialize_template(FILE *fperr,
	int dbg,
	template *tmp,
	ipt dim,
	search srch,
	pt delta,
	float ***cova_table);

float
lookup_cova(int dx,
	int dy,
	int dz,
	float ***cova_table);

void
a_few_checks(int ndata,
	int ntemp,
	int ncov,
	int nvar,
	int nvar_sim,
	ipt n_nodes,
	ipt from,
	ipt to,
	pt delta);

void
qcksrt(int n,
	float arr[],
	int indx[]);
	
void
hpsort(int n,
	float arr[],
	int indx[]);

float
rand0(long *idum);

void
read_in_geometry(FILE *fp,
	FILE *fperr,
	long int *seed,
	int *nsim,
	int *max_data,
	pt *delta,
	pt *origin,
	ipt *n_nodes,
	ipt *from,
	ipt *to,
	search *srch,
	int *max_per_octant,
	int *dbg);

int
findout_rotation(float cosines[3][3]);

int
read_in_variograms(FILE *fp,
	FILE *fperr,
	int *nvar_sim,
	int *simulation_var[],
	float *expected_value[],
	variogram_model *variogram[]);

void
input_structure(FILE *fp,
	variogram_model *var_model);

void
print_structure(FILE *fp,
	variogram_model *var_model);

int
read_in_conditioning_data(FILE *fp,
	FILE *fperr,
	pt **coord_pointer,
	int **index_pointer,
	float **value_pointer);

float *
vector(int nl,
	int nh);

int *
ivector(int nl,
	int nh);

long *
lvector(long nl,
	long nh);

double *
dvector(int nl,
	int nh);

float **
matrix(int nrl,
	int nrh,
	int ncl,
	int nch);

float ***
tensor(int nrl,
	int nrh,
	int ncl,
	int nch,
	int nll,
	int nlh);

void
free_vector(float *v,
	int nl,
	int nh);

void
free_ivector(int *v,
	int nl,
	int nh);

void
free_lvector(long *v,
	long nl,
	long nh);

void
free_matrix(float **m,
	int nrl,
	int nrh,
	int ncl,
	int nch);

int **
imatrix(int nrl,
	int nrh,
	int ncl,
	int nch);

void
error(char *err);

void
print_header(FILE *fperr);

/* Protoypes grabbed from file
** "gsim11.c"
** 1992 Aug 25 (Tue) 12:39:16
*/

void
do_simulation(FILE *fperr,
	ipt n_nodes,
	ipt from,
	ipt to,
	int max_per_octant,
	int nvar,
	int nvar_sim,
	int *simulation_var,
	float expected_value[],
	float ****node,
	short ***node_flag,
	int ntemp,
	template *tmp,
	long int *seed,
	float ***cova_table[],
	int **lookup_table,
	int dbg,
	int max_data,
        int isim);

float
obtain_SK_estimate(int npoints,
	int ivar,
	float *expected_value);

void
free_memory(int nvar,
	int max_data);	
	
void
allocate_conditioning_data_matrices(int nvar,
	int max_data);

void
initialize_random_path(FILE *fperr,
    long *seed);

ipt
get_next_point(ipt from,
    long int);

int
find_conditioning_points(FILE *fperr,
	ipt n_nodes,
	ipt point,
	float ****node,
	short ***node_flag,
	int ntemp,
	int max_per_octant,
	template *tmp,
	int nvar,
	int *simulation_var,
	int max_data);

void
build_kriging_system(FILE *fperr,
	int ivar,
	ipt point,
	int npoints,
	float ****cova_table,
	int **lookup_table,
	int dbg);

void
solve_kriging_system(int nequations);

float
obtain_SK_kriging_variance(FILE *fperr,
	ipt point,
	int npoints,
	int ivar,
	float ****cova_table,
	int **lookup_table,
	int dbg);

void
write_out_kriging_weights(FILE *fperr,
	int npoints);

void
write_out_cpdf(FILE *fperr,
	float value);

void
ludcmp(float **a,
	int n,
	int *indx,
	float *d);

void
lubksb(float **a,
	int n,
	int *indx,
	float b[]);

float
gasdev(long *idum);


